diff --git a/src/test/modules/test_checksums/test_checksums.c b/src/test/modules/test_checksums/test_checksums.c
new file mode 100644
index 00000000000..b087a3b4664
--- /dev/null
+++ b/src/test/modules/test_checksums/test_checksums.c
@@ -0,0 +1,184 @@
+/*--------------------------------------------------------------------------
+ *
+ * test_checksums.c
+ *		Test data checksums
+ *
+ * Copyright (c) 2026, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *		src/test/modules/test_checksums/test_checksums.c
+ *
+ * -------------------------------------------------------------------------
+ */
+#include "postgres.h"
+
+#include "funcapi.h"
+#include "miscadmin.h"
+#include "postmaster/datachecksum_state.h"
+#include "storage/latch.h"
+#include "utils/injection_point.h"
+#include "utils/wait_event.h"
+
+PG_MODULE_MAGIC;
+
+extern PGDLLEXPORT void dc_delay_barrier(const char *name, const void *private_data, void *arg);
+extern PGDLLEXPORT void dc_modify_db_result(const char *name, const void *private_data, void *arg);
+extern PGDLLEXPORT void dc_fake_temptable(const char *name, const void *private_data, void *arg);
+
+extern PGDLLEXPORT void crash(const char *name, const void *private_data, void *arg);
+
+/*
+ * Test for delaying emission of procsignalbarriers.
+ */
+void
+dc_delay_barrier(const char *name, const void *private_data, void *arg)
+{
+	(void) name;
+	(void) private_data;
+
+	(void) WaitLatch(MyLatch,
+					 WL_LATCH_SET | WL_TIMEOUT | WL_EXIT_ON_PM_DEATH,
+					 (3 * 1000),
+					 WAIT_EVENT_PG_SLEEP);
+}
+
+PG_FUNCTION_INFO_V1(dcw_inject_delay_barrier);
+Datum
+dcw_inject_delay_barrier(PG_FUNCTION_ARGS)
+{
+#ifdef USE_INJECTION_POINTS
+	bool		attach = PG_GETARG_BOOL(0);
+
+	if (attach)
+		InjectionPointAttach("datachecksums-enable-checksums-delay",
+							 "test_checksums",
+							 "dc_delay_barrier",
+							 NULL,
+							 0);
+	else
+		InjectionPointDetach("datachecksums-enable-checksums-delay");
+#else
+	elog(ERROR,
+		 "test is not working as intended when injection points are disabled");
+#endif
+	PG_RETURN_VOID();
+}
+
+PG_FUNCTION_INFO_V1(dcw_inject_launcher_delay);
+Datum
+dcw_inject_launcher_delay(PG_FUNCTION_ARGS)
+{
+#ifdef USE_INJECTION_POINTS
+	bool		attach = PG_GETARG_BOOL(0);
+
+	if (attach)
+		InjectionPointAttach("datachecksumsworker-launcher-delay",
+							 "test_checksums",
+							 "dc_delay_barrier",
+							 NULL,
+							 0);
+	else
+		InjectionPointDetach("datachecksumsworker-launcher-delay");
+#else
+	elog(ERROR,
+		 "test is not working as intended when injection points are disabled");
+#endif
+	PG_RETURN_VOID();
+}
+
+PG_FUNCTION_INFO_V1(dcw_inject_startup_delay);
+Datum
+dcw_inject_startup_delay(PG_FUNCTION_ARGS)
+{
+#ifdef USE_INJECTION_POINTS
+	bool		attach = PG_GETARG_BOOL(0);
+
+	if (attach)
+		InjectionPointAttach("datachecksumsworker-startup-delay",
+							 "test_checksums",
+							 "dc_delay_barrier",
+							 NULL,
+							 0);
+	else
+		InjectionPointDetach("datachecksumsworker-startup-delay");
+#else
+	elog(ERROR,
+		 "test is not working as intended when injection points are disabled");
+#endif
+	PG_RETURN_VOID();
+}
+
+static uint32 db_fail = DATACHECKSUMSWORKER_FAILED;
+
+void
+dc_modify_db_result(const char *name, const void *private_data, void *arg)
+{
+	DataChecksumsWorkerResult *res = (DataChecksumsWorkerResult *) arg;
+	uint32		new_res = *(uint32 *) private_data;
+
+	*res = new_res;
+}
+
+PG_FUNCTION_INFO_V1(dcw_inject_fail_database);
+Datum
+dcw_inject_fail_database(PG_FUNCTION_ARGS)
+{
+#ifdef USE_INJECTION_POINTS
+	bool		attach = PG_GETARG_BOOL(0);
+
+	if (attach)
+		InjectionPointAttach("datachecksumsworker-modify-db-result",
+							 "test_checksums",
+							 "dc_modify_db_result",
+							 &db_fail,
+							 sizeof(uint32));
+	else
+		InjectionPointDetach("datachecksumsworker-modify-db-result");
+#else
+	elog(ERROR,
+		 "test is not working as intended when injection points are disabled");
+#endif
+	PG_RETURN_VOID();
+}
+
+/*
+ * Test to force waiting for existing temptables.
+ */
+void
+dc_fake_temptable(const char *name, const void *private_data, void *arg)
+{
+	static bool first_pass = true;
+	int		   *numleft = (int *) arg;
+
+	if (first_pass)
+		*numleft = 1;
+	first_pass = false;
+}
+
+PG_FUNCTION_INFO_V1(dcw_fake_temptable);
+Datum
+dcw_fake_temptable(PG_FUNCTION_ARGS)
+{
+#ifdef USE_INJECTION_POINTS
+	bool		attach = PG_GETARG_BOOL(0);
+
+	if (attach)
+		InjectionPointAttach("datachecksumsworker-fake-temptable-wait",
+							 "test_checksums",
+							 "dc_fake_temptable",
+							 NULL,
+							 0);
+	else
+		InjectionPointDetach("datachecksumsworker-fake-temptable-wait");
+#else
+	elog(ERROR,
+		 "test is not working as intended when injection points are disabled");
+#endif
+	PG_RETURN_VOID();
+}
+
+void
+crash(const char *name, const void *private_data, void *arg)
+{
+	abort();
+}
diff --git a/src/test/modules/test_checksums/test_checksums.control b/src/test/modules/test_checksums/test_checksums.control
new file mode 100644
index 00000000000..84b4cc035a7
--- /dev/null
+++ b/src/test/modules/test_checksums/test_checksums.control
@@ -0,0 +1,4 @@
+comment = 'Test code for data checksums'
+default_version = '1.0'
+module_pathname = '$libdir/test_checksums'
+relocatable = true
diff --git a/src/test/perl/PostgreSQL/Test/Cluster.pm b/src/test/perl/PostgreSQL/Test/Cluster.pm
index f8dc732e66e..54e6b646e8f 100644
--- a/src/test/perl/PostgreSQL/Test/Cluster.pm
+++ b/src/test/perl/PostgreSQL/Test/Cluster.pm
@@ -3898,6 +3898,42 @@ sub advance_wal
 	}
 }
 
+=item $node->checksum_enable_offline()
+
+Enable data page checksums in an offline cluster with B<pg_checksums>. The
+caller is responsible for ensuring that the cluster is in the right state for
+this operation.
+
+=cut
+
+sub checksum_enable_offline
+{
+	my ($self) = @_;
+
+	print "# Enabling checksums in \"$self->data_dir\"\n";
+	PostgreSQL::Test::Utils::system_or_bail('pg_checksums', '-D',
+		$self->data_dir, '-e');
+	return;
+}
+
+=item $node->checksum_disable_offline()
+
+Disable data page checksums in an offline cluster with B<pg_checksums>. The
+caller is responsible for ensuring that the cluster is in the right state for
+this operation.
+
+=cut
+
+sub checksum_disable_offline
+{
+	my ($self) = @_;
+
+	print "# Disabling checksums in \"$self->data_dir\"\n";
+	PostgreSQL::Test::Utils::system_or_bail('pg_checksums', '-D',
+		$self->data_dir, '-d');
+	return;
+}
+
 =pod
 
 =back
diff --git a/src/tools/pgindent/typedefs.list b/src/tools/pgindent/typedefs.list
index 91b1225da82..ad999aa48dd 100644
--- a/src/tools/pgindent/typedefs.list
+++ b/src/tools/pgindent/typedefs.list
@@ -438,6 +438,8 @@ CheckPointStmt
 CheckpointStatsData
 CheckpointerRequest
 CheckpointerShmemStruct
+ChecksumBarrierCondition
+ChecksumStateType
 Chromosome
 CkptSortItem
 CkptTsStatus
@@ -610,6 +612,7 @@ CustomScan
 CustomScanMethods
 CustomScanState
 CycleCtr
+DataChecksumsWorkerOperation
 DBState
 DbOidName
 DCHCacheEntry
@@ -628,6 +631,9 @@ DSMREntryType
 DSMRegistryCtxStruct
 DSMRegistryEntry
 DWORD
+DataChecksumsWorkerDatabase
+DataChecksumsWorkerResult
+DataChecksumsStateStruct
 DataDirSyncMethod
 DataDumperPtr
 DataPageDeleteStack
@@ -4405,6 +4411,7 @@ xl_btree_unlink_page
 xl_btree_update
 xl_btree_vacuum
 xl_checkpoint_redo
+xl_checksum_state
 xl_clog_truncate
 xl_commit_ts_truncate
 xl_dbase_create_file_copy_rec
-- 
2.39.3 (Apple Git-146)

